scala.tools.nsc.backend.icode

# ICodeCheckers

#### abstract class ICodeCheckers extends AnyRef

Source
  ICodeCheckers.scala

Linear Supertypes
AnyRef, Any
Known Subclasses
icodeCheckers
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. ICodeCheckers
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new ICodeCheckers()

### Type Members

1. #### class ICodeChecker extends AnyRef

   This class performs a set of checks similar to what the bytecode verifier does.

   This class performs a set of checks similar to what the bytecode verifier does. For each basic block, it checks that:

   - for primitive operations: the type and numer of operands match the type of the operation

   - for method calls: the method exists in the type of the receiver and the number and type of arguments match the declared type of the method.

   - for object creation: the constructor can be called.

   - for load/stores: the field/local/param exists and the type of the value matches that of the target.

   For a control flow graph it checks that type stacks at entry to each basic block 'agree':

   - they have the same length
   - there exists a lub for all types at the same position in stacks.
   Version

     1.0, 06/09/2005

   To do

     Iulian says: I think there's some outdated logic in the checker. The issue with exception handlers being special for least upper bounds pointed out some refactoring in the lattice class. Maybe a worthwhile refactoring would be to make the checker use the DataFlowAnalysis class, and use the lattice trait. In the implementation of LUB, there's a flag telling if one of the successors is 'exceptional'. The inliner is using this mechanism.

     ,

     Better checks for `MONITOR_ENTER/EXIT` Better checks for local var initializations

### Abstract Value Members

1. #### abstract val global: Global

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from ICodeCheckers to any2stringadd[ICodeCheckers] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (ICodeCheckers, B)

   Implicit information
     This member is added by an implicit conversion from ICodeCheckers to ArrowAssoc[ICodeCheckers] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

6. #### final def asInstanceOf[T0]: T0

   Definition Classes
     Any

7. #### def clone(): AnyRef

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )

8. #### def ensuring(cond: (ICodeCheckers) ⇒ Boolean, msg: ⇒ Any): ICodeCheckers

   Implicit information
     This member is added by an implicit conversion from ICodeCheckers to Ensuring[ICodeCheckers] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring

9. #### def ensuring(cond: (ICodeCheckers) ⇒ Boolean): ICodeCheckers

   Implicit information
     This member is added by an implicit conversion from ICodeCheckers to Ensuring[ICodeCheckers] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring

10. #### def ensuring(cond: Boolean, msg: ⇒ Any): ICodeCheckers

    Implicit information
      This member is added by an implicit conversion from ICodeCheckers to Ensuring[ICodeCheckers] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

11. #### def ensuring(cond: Boolean): ICodeCheckers

    Implicit information
      This member is added by an implicit conversion from ICodeCheckers to Ensuring[ICodeCheckers] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

12. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

13. #### def equals(arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

14. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

15. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from ICodeCheckers to StringFormat[ICodeCheckers] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

16. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

17. #### def hashCode(): Int

    Definition Classes
      AnyRef → Any

18. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

19. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

20. #### final def notify(): Unit

    Definition Classes
      AnyRef

21. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

22. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

23. #### def toString(): String

    Definition Classes
      AnyRef → Any

24. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

25. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

26. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

27. #### def →[B](y: B): (ICodeCheckers, B)

    Implicit information
      This member is added by an implicit conversion from ICodeCheckers to ArrowAssoc[ICodeCheckers] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from ICodeCheckers to any2stringadd[ICodeCheckers]

### Inherited by implicit conversion StringFormat from ICodeCheckers to StringFormat[ICodeCheckers]

### Inherited by implicit conversion Ensuring from ICodeCheckers to Ensuring[ICodeCheckers]

### Inherited by implicit conversion ArrowAssoc from ICodeCheckers to ArrowAssoc[ICodeCheckers]

### Ungrouped